routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});
Route::post('/results', 'ReparationController@get_info')->name('results');

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::group(['middleware' => 'auth'], function () {
    Route::resource('/voitures', 'VoitureController')->except('destroy');
    Route::get('/voitures/delete/{id}', 'VoitureController@destroy')->name('voitures.destroy');


    Route::get('/get_modeles/{id}','MarqueController@get_modeles');


    Route::resource('/clients', 'ClientController')->except('destroy');
    Route::get('/clients/delete/{id}', 'ClientController@destroy')->name('clients.destroy');


    Route::resource('/reparations', 'ReparationController')->except('destroy');
    Route::get('/reparations/delete/{id}', 'ReparationController@destroy')->name('reparations.destroy');


    Route::resource('/interventions', 'InterventionController')->except('destroy');
    Route::get('/interventions/delete/{id}', 'InterventionController@destroy')->name('interventions.destroy');


});

app/Reparation.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Reparation extends Model
{
    public function clients(){
        return $this->belongsTo('App\User','client_id');
    }

    public function interventions(){
        return $this->belongsTo('App\Intervention','intervention_id');
    }

    public function voitures(){
        return $this->belongsTo('App\Voiture','voiture_id');
    }
}

app/Http/Controllers/ReparationController.php
<?php

namespace App\Http\Controllers;

use App\Intervention;
use App\Reparation;
use App\User;
use App\Voiture;
use Facade\FlareClient\Http\Client;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Http\Request;

class ReparationController extends Controller
{

    public function get_info(Request $request)
    {
        $rep = Reparation::where('random_code',$request->code)->get();

        return view('welcome')->with('rep',$rep);
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $reparations = Reparation::all();

        return view('backend.reparations.index',compact('reparations'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $voitures = Voiture::all();
        $interventions = Intervention::all();
        $clients = User::all();


        return view('backend.reparations.create',compact('voitures','interventions','clients'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        $this->validate(request(), [
            'client_id' => 'required',
            'voiture_id' => 'required',
            'intervention_id' => 'required',
        ]);

        $client_id=$request->client_id;
        $voiture_ids=$request->voiture_id;
        $interventions=$request->intervention_id;

        $selected_interventions=[];
        foreach ($interventions as $int){
            if($int)
                $selected_interventions[]=$int;
        }

        $counter =0 ;
        foreach ($voiture_ids as $v)
        {
            $reparations = new  Reparation();
            $reparations->client_id = $client_id;
            $reparations->voiture_id = $v;
            $reparations->intervention_id = $selected_interventions[$counter];
            $reparations->save();
            $counter++;
        }

        return redirect()->back()->with('success', 'Réparation ajouté avec succés');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Reparation  $reparation
     * @return \Illuminate\Http\Response
     */
    public function show(Reparation $reparation)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Reparation  $reparation
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $clients = User::all();
        $reparation = Reparation::find($id);
        $voitures = Voiture::all();
        $interventions = Intervention::all();

        return view('backend.reparations.edit',compact('reparation','clients','voitures','interventions'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Reparation  $reparation
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $this->validate(request(), [
            'client_id' => 'required',
            'voiture_id' => 'required',
            'intervention_id' => 'required',
        ]);

        $reparations = Reparation::find($id);
        $reparations->client_id = $request->client_id;
        $reparations->voiture_id = $request->voiture_id;
        $reparations->intervention_id = $request->intervention_id;
        $reparations->date_int = $request->date_int;
        $reparations->status = $request->status;

        $uniqid = uniqid();

        $rand_start = rand(1,5);

        $rand_8_char = substr($uniqid,$rand_start,8);

        $reparations->random_code = $rand_8_char;
        $reparations->save();

        return redirect('/reparations')->with('success', 'Réparation éditer avec succés');

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Reparation  $reparation
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $reparations = Reparation::find($id)->delete();

        return redirect()->back()->with('errors', 'Réparation supprimé avec succés');
    }
}

resources/views/backend/reparations/create.blade.php
@extends('layouts.dashboard')

@section('content')

    <section class="content">
        <div class="card card-primary">
            <div class="card-header">
                <h3 class="card-title">Ajouter Réparation</h3>
            </div>
            <!-- /.card-header -->
            <!-- form start -->
            <form method="post" action="{{route('reparations.store')}}">
                @csrf
                <div class="card-body">
                    @if(count($errors))
                        <div class="form-group">
                            <div class="alert alert-danger">
                                <ul>
                                    @foreach($errors->all() as $error)
                                        <li>{{$error}}</li>
                                    @endforeach
                                </ul>
                            </div>
                        </div>
                    @endif
                    @if (\Session::has('success'))
                        <div class="alert alert-success">
                            <ul>
                                <li>{!! \Session::get('success') !!}</li>
                            </ul>
                        </div>
                    @endif

                    <div class="form-group">
                        <label for="exampleInputEmail1">Client</label>
                        <select name="client_id" class="form-control">
                            <option>Selectionner client</option>
                            @foreach($clients as $client)
                                <option value="{{$client->id}}">{{$client->name}}</option>
                            @endforeach
                        </select>
                    </div>

                    <table class="table table-bordered table-hover">
                        @foreach($voitures as $v)
                            <tr>
                                <td width="5%"><input type="checkbox" name="voiture_id[]" value="{{$v->id}}"></td>
                                <td>{{$v->titre}}</td>
                                <td>
                                    <select name="intervention_id[]" class="form-control">
                                        @foreach($interventions as $int)
                                            <option value="{{$int->id}}">{{$int->libelle}}</option>
                                        @endforeach
                                    </select>
                                </td>
                            </tr>
                        @endforeach
                    </table>
                </div>
                <!-- /.card-body -->

                <div class="card-footer">
                    <button type="submit" class="btn btn-primary">Submit</button>
                </div>
            </form>
        </div>
    </section>

@endsection

resources/views/backend/reparations/edit.blade.php
@extends('layouts.dashboard')

@section('content')

    <section class="content">
        <div class="card card-primary">
            <div class="card-header">
                <h3 class="card-title">Modifier Réparation</h3>
            </div>
            <!-- /.card-header -->
            <!-- form start -->
            <form method="post" action="{{route('reparations.update',$reparation->id)}}">
                @csrf
                {{ method_field('PUT') }}

                <div class="card-body">
                    @if(count($errors))
                        <div class="form-group">
                            <div class="alert alert-danger">
                                <ul>
                                    @foreach($errors->all() as $error)
                                        <li>{{$error}}</li>
                                    @endforeach
                                </ul>
                            </div>
                        </div>
                    @endif
                    @if (\Session::has('success'))
                        <div class="alert alert-success">
                            <ul>
                                <li>{!! \Session::get('success') !!}</li>
                            </ul>
                        </div>
                    @endif

                    <div class="form-group">
                        <label for="exampleInputEmail1">Client</label>
                        <select name="client_id" class="form-control">
                            <option>Selectionner client</option>
                            @foreach($clients as $client)
                                <option value="{{$client->id}}"
                                        @if($reparation->client_id == $client->id) selected @endif>{{$client->name}}</option>
                            @endforeach
                        </select>
                    </div>

                    <div class="form-group">
                        <label for="exampleInputEmail1">Voitures</label>
                        <select name="voiture_id" class="form-control">
                            <option>Selectionner voitures</option>
                            @foreach($voitures as $v)
                                <option value="{{$v->id}}"
                                        @if($reparation->voiture_id == $v->id) selected @endif>{{$v->titre}}</option>
                            @endforeach
                        </select>
                    </div>

                        <div class="form-group">
                            <label for="exampleInputEmail1">Interventions</label>
                            <select name="intervention_id" class="form-control">
                                <option>Selectionner interventions</option>
                                @foreach($interventions as $i)
                                    <option value="{{$i->id}}"
                                            @if($reparation->intervention_id == $i->id) selected @endif>{{$i->libelle}}</option>
                                @endforeach
                            </select>
                        </div>
                        <div class="form-group">
                            <label for="exampleInputEmail1">Date</label>
                            <input class="form-control" type="date" name="date_int" value="{{$reparation->date_int}}">
                        </div>

                        <div class="form-group">
                            <label for="exampleInputEmail1">Status</label>
                            <input class="form-control" type="text" name="status" value="{{$reparation->status}}">
                        </div>

                </div>
                <!-- /.card-body -->




                <div class="card-footer">
                    <button type="submit" class="btn btn-primary">Submit</button>
                </div>
            </form>
        </div>
    </section>

@endsection

resources/views/backend/reparations/index.blade.php
@extends('layouts.dashboard')

@section('content')
    <section class="content">
        <div class="container-fluid">
            <div class="row">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header">
                            <div style="float: right">
                                <a href="{{route('reparations.create')}}" class="btn btn-success">Ajouter réparation</a>
                            </div>
                        </div>
                        <!-- /.card-header -->
                        <div class="card-body">
                            @if (\Session::has('errors'))
                                <div class="alert alert-danger">
                                    <ul>
                                        <li>{!! \Session::get('errors') !!}</li>
                                    </ul>
                                </div>
                            @endif
                            <table id="example2" class="table table-bordered table-hover">
                                <thead>
                                <tr>
                                    <th>Client</th>
                                    <th>Intervention</th>
                                    <th>Voiture</th>
                                    <th>Date</th>
                                    <th>Action</th>
                                </tr>
                                </thead>
                                <tbody>
                                @foreach($reparations as $v)
                                    <tr>
                                        <td>{{$v->clients->name}}</td>
                                        <td>{{$v->interventions->libelle}}
                                        </td>
                                        <td>{{$v->voitures->titre}}</td>
                                        <td>{{$v->date_int}}</td>

                                        <td>
                                            <a href="{{route('reparations.show',$v->id)}}"class="btn btn-warning">Afficher</a>
                                            <a href="{{route('reparations.edit',$v->id)}}" class="btn btn-info">Editer</a>
                                            <a href="{{route('reparations.destroy',$v->id)}}" class="btn btn-danger"><i class="fa fa-trash"></i> </a>

                                        </td>
                                    </tr>
                                @endforeach

                                </tfoot>
                            </table>
                        </div>
                        <!-- /.card-body -->
                    </div>
                    <!-- /.card -->
                </div>
                <!-- /.col -->
            </div>
            <!-- /.row -->
        </div>
    </section>

@endsection